package com.iot.modbus_rtcp.utils;

public class HexUtil {

    public static byte[] hexStringToBytes(String src) {
        int l = src.length() / 2;
        byte[] ret = new byte[l];
        for (int i = 0; i < l; i++) {
            ret[i] = (byte) Integer.valueOf(src.substring(i * 2, i * 2 + 2), 16).byteValue();
        }
        return ret;
    }

    public static String bytesToHexString(byte[] src) {
        String strHex = "";
        StringBuilder sb = new StringBuilder("");
        for (int n = 0; n < src.length; n++) {
            strHex = Integer.toHexString(src[n] & 0xFF);
            // 每个字节由两个字符表示，位数不够，高位补0
            sb.append((strHex.length() == 1) ? "0" + strHex : strHex);
        }
        return sb.toString().trim().toUpperCase();
    }

    public static int hashPartition(String key, int partition) {
        return Math.abs(key.hashCode() % partition);
    }

    public static void main(String[] args) {
        System.out.println(hexStringToBytes("0D"));
        System.out.println(new byte[]{(byte) Integer.parseInt("0D", 16)});
    }
}
